<script lang="ts">
import Vue from 'vue';

export default Vue.extend({
  props: {
    data: {
      type: Object,
      required: true,
      default() {
        return {};
      },
    },
  },
  data() {
    return {
      quoteIndex: 0,
    };
  },
  methods: {
    nextQuote() {
      if (this.quoteIndex === this.data.quotes.length - 1) {
        this.quoteIndex = 0;
      } else {
        this.quoteIndex++;
      }
    },
    previousQuote() {
      if (this.quoteIndex === 0) {
        this.quoteIndex = this.data.quotes.length - 1;
      } else {
        this.quoteIndex--;
      }
    },
  },
});
</script>

<template>
  <div class="quote-wrapper">
    <SlpButton class="button" variant="ghost" @click.native="previousQuote">
      <SlpIcon
        name="chevron-lg-left"
        variant="product"
        alt="Chevron left Icon"
        size="md"
        class="button-previous"
      />
    </SlpButton>
    <div class="quote-container">
      <!--  TODO: add this icon to Slippers -->
      <svg width="30" height="25" fill="none" class="quote-icon">
        <path
          d="M10.79.19C4.07 3.48.85 8.59.85 15.17c0 5.74 2.24 9.17 6.58 9.17 3.08 0 5.39-2.24 5.39-5.74 0-3.15-2.45-5.11-5.39-5.11-.21 0-.49 0-.7.07 0-4.2 2.1-6.79 6.3-8.89L10.79.19zm16.59 0c-6.72 3.29-10.01 8.4-10.01 14.98 0 5.74 2.31 9.17 6.65 9.17 3.08 0 5.32-2.24 5.32-5.74 0-3.15-2.38-5.11-5.32-5.11-.21 0-.49 0-.7.07 0-4.2 2.1-6.79 6.3-8.89L27.38.19z"
          fill="#A989F5"
        />
      </svg>
      <transition name="fade" mode="out-in">
        <SlpTypography
          :key="quoteIndex"
          variant="heading5-bold"
          tag="p"
          class="quote"
        >
          {{ data.quotes[quoteIndex].text }}</SlpTypography
        >
      </transition>
      <transition name="fade" mode="out-in">
        <SlpTypography :key="quoteIndex" variant="body3" tag="p" class="author"
          >- {{ data.quotes[quoteIndex].author }}</SlpTypography
        >
      </transition>
    </div>
    <SlpButton variant="ghost" class="button" @click.native="nextQuote">
      <SlpIcon
        name="chevron-lg-right"
        variant="product"
        alt="Chevron Right Icon"
        class="button-next"
        size="md"
      />
    </SlpButton>
  </div>
</template>

<style lang="scss" scoped>
.button {
  @media (max-width: $breakpoint-lg) {
    padding: 0;
    .button-previous {
      margin-right: $spacing-16;
      margin-left: auto;
    }
    .button-next {
      margin-left: $spacing-16;
    }
  }
  cursor: pointer;
  &-previous {
    margin-right: $spacing-32;
  }
  &-next {
    margin-left: $spacing-32;
  }
}

.quote-wrapper {
  width: 100%;
  display: flex;
  margin-top: 50px;
  justify-content: center;
  margin-bottom: 120px;
  align-items: center;
}
.quote-container {
  max-width: 60%;
  height: 270px;
  position: relative;
  padding: $spacing-64;
  border: 2px solid transparent;
  border-radius: 4px;
  background: linear-gradient(
        90deg,
        $color-secondary-200 0%,
        $color-secondary-200 100%
      )
      padding-box,
    linear-gradient(90deg, #e2b6f1 0%, #7759c2 100%) border-box;
  border-radius: 4px;
  border-image-source: linear-gradient(90deg, #e2b6f1 0%, #7759c2 100%);
  .author,
  .quote {
    margin-top: $spacing-8;
  }

  @media (max-width: $breakpoint-lg) {
    padding: $spacing-16;
    max-width: 100%;
    min-width: 78%;
  }
  @media (min-width: $breakpoint-lg) {
    height: 300px;
  }
}

.quote-container:before {
  position: absolute;
  content: '';
  width: 0;
  height: 0;
  bottom: -18px;
  left: 50%;
  border-left: 18px solid transparent;
  border-bottom: 0px solid transparent;
  border-right: 18px solid transparent;
  border-top: 18px solid #7759c2;
}

.quote-container:after {
  position: absolute;
  content: '';
  width: 0;
  height: 0;
  bottom: -17px;
  left: 50%;
  border-left: 18px solid transparent;
  border-bottom: 1px solid transparent;
  border-right: 18px solid transparent;
  border-top: 18px solid white;
}

// Quote transition

.fade-leave-active {
  transition: all 0.3s ease-in;
}
.fade-enter-active {
  transition: all 0.5s;
}
.fade-enter,
.fade-leave-to {
  opacity: 0;
  transform: translateX(20px);
}
.fade-leave,
.fade-enter-to {
  opacity: 1;
}
</style>
